cf Educational Codeforces Round 25 C - Multi-judge Solvingz

2024-03-24 08:08

本文主要是介绍cf Educational Codeforces Round 25 C - Multi-judge Solvingz,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

原题:
D. Suitable Replacement
time limit per test1 second
memory limit per test256 megabytes
inputstandard input
outputstandard output
You are given two strings s and t consisting of small Latin letters, string s can also contain ‘?’ characters.

Suitability of string s is calculated by following metric:

Any two letters can be swapped positions, these operations can be performed arbitrary number of times over any pair of positions. Among all resulting strings s, you choose the one with the largest number of non-intersecting occurrences of string t. Suitability is this number of occurrences.

You should replace all ‘?’ characters with small Latin letters in such a way that the suitability of string s is maximal.

Input
The first line contains string s (1 ≤ |s| ≤ 10^6).

The second line contains string t (1 ≤ |t| ≤ 10^6).

Output
Print string s with ‘?’ replaced with small Latin letters in such a way that suitability of that string is maximal.

If there are multiple strings with maximal suitability then print any of them.

Examples

input
?aa?
ab
output
baab
input
??b?
za
output
azbz
input
abcd
abacaba
output
abcd

Note
In the first example string “baab” can be transformed to “abab” with swaps, this one has suitability of 2. That means that string “baab” also has suitability of 2.

In the second example maximal suitability you can achieve is 1 and there are several dozens of such strings, “azbz” is just one of them.

In the third example there are no ‘?’ characters and the suitability of the string is 0.

中文:
给你两个字符串s和t,其中s当中每个字符的位置可以随意改变。且s中包含‘?’字符。
现在问你可以将s变成任意一个字符,那么s当中最多可以有多个子串t?

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
string s,t;
ll hs[26],ht[26],tmp[26],mark;
int main()
{ios::sync_with_stdio(false);while(cin>>s>>t){memset(hs,0,sizeof(hs));memset(ht,0,sizeof(ht));memset(tmp,0,sizeof(tmp));mark=0;if(t.size()>s.size()){for(auto &x:s)if(x=='?'){x='a';}cout<<s<<endl;continue;}for(auto x:t)ht[x-'a']++;for(auto x:s){if(x=='?')mark++;elsehs[x-'a']++;}int l=0,r=(s.size()/t.size()),m;while(r-l>=0){m=(r+l)/2;int flag=0;int res=mark;for(int i=0;i<26;i++){if(ht[i]*m-hs[i]>0)res-=(ht[i]*m-hs[i]);if(res<0){flag=1;break;}}if(flag==1)//缩小r=m-1;elsel=m+1;}//取rfor(int i=0;i<26;i++){if(ht[i]*r-hs[i]>=0)ht[i]=(ht[i]*r-hs[i]);elseht[i]=0;}for(int i=0;i<s.size();i++){if(s[i]=='?'){for(int j=0;j<26;j++){if(ht[j]>0){ht[j]--;s[i]=('a'+j);break;}}}}for(auto &x:s)if(x=='?')x='z';cout<<s<<endl;}return 0;
}

思路:

由题意可以得知,由于s的所有字符的位置都是可以变化的,那么和字符串的顺序就没有关系。就是问你在t传当中的每个字符可以扩大相同的倍数以后,在s中的’?’改变为字母以后,s中每个字符数目是否大于等于t中的字符。

二分倍数,然后找最大的即可。

这篇关于cf Educational Codeforces Round 25 C - Multi-judge Solvingz的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/840965

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

cf 164 C 费用流

给你n个任务,k个机器,n个任务的起始时间,持续时间,完成任务的获利 每个机器可以完成任何一项任务,但是同一时刻只能完成一项任务,一旦某台机器在完成某项任务时,直到任务结束,这台机器都不能去做其他任务 最后问你当获利最大时,应该安排那些机器工作,即输出方案 具体建图方法: 新建源汇S T‘ 对任务按照起始时间s按升序排序 拆点: u 向 u'连一条边 容量为 1 费用为 -c,

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

2014 Multi-University Training Contest 8小记

1002 计算几何 最大的速度才可能拥有无限的面积。 最大的速度的点 求凸包, 凸包上的点( 注意不是端点 ) 才拥有无限的面积 注意 :  凸包上如果有重点则不满足。 另外最大的速度为0也不行的。 int cmp(double x){if(fabs(x) < 1e-8) return 0 ;if(x > 0) return 1 ;return -1 ;}struct poin

2014 Multi-University Training Contest 7小记

1003   数学 , 先暴力再解方程。 在b进制下是个2 , 3 位数的 大概是10000进制以上 。这部分解方程 2-10000 直接暴力 typedef long long LL ;LL n ;int ok(int b){LL m = n ;int c ;while(m){c = m % b ;if(c == 3 || c == 4 || c == 5 ||

2014 Multi-University Training Contest 6小记

1003  贪心 对于111...10....000 这样的序列,  a 为1的个数,b为0的个数,易得当 x= a / (a + b) 时 f最小。 讲串分成若干段  1..10..0   ,  1..10..0 ,  要满足x非递减 。  对于 xi > xi+1  这样的合并 即可。 const int maxn = 100008 ;struct Node{int

CF 508C

点击打开链接 import java.util.Arrays;import java.util.Scanner;public class Main {public static void main(String [] args){new Solve().run() ;} }class Solve{int bit[] = new int[608] ;int l

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja